#include <antiglut.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#define N	1000

typedef GLfloat	vec3_t[3];

vec3_t	vert[N];

static GLfloat alpha = 0, beta = 0;

static void draw()
{
	int i;
	glClear(GL_COLOR_BUFFER_BIT);
	glLoadIdentity();
	glScalef(0.7f,0.7f,0.7f);
	glRotatef(alpha,1,0,0);
	glRotatef(beta,0,1,0);
	glLineWidth(1.4f);
	glBegin(GL_LINES);
		for(i = 0;i < N;i++)
		{
			glColor4f(1,1,0,0.2f);
			glVertex3f(0,0,0);
			glColor4f(1,1,1,0.4f);
			glVertex3fv(vert[i]);
		}
	glEnd();
	glLineWidth(5.0f);
	glBegin(GL_LINES);
		glColor4f(1,.5,.5,.5f);
		glVertex3f(0,0,0);
		glVertex3f(1,0,0);
		glColor4f(.5f,1,.5f,.5f);
		glVertex3f(0,0,0);
		glVertex3f(0,1,0);
		glColor4f(.5f,.5f,1,.5f);
		glVertex3f(0,0,0);
		glVertex3f(0,0,1);
	glEnd();
	agSwap();
}

int main()
{
	int i;
	ui_event_t	ev;
	agWindowConfig("TEST",
		800,800,GL_FALSE);
	if(!agInit(AG_REQUIRED_1_1,GL_FALSE,GL_FALSE,GL_FALSE))
		return -1;
	for(i = 0;i < N;i++)
	{
		GLfloat t, p;
		t = (GLfloat)rand() / RAND_MAX;
		p = (GLfloat)rand() / RAND_MAX;
		t *= M_PI;
		p *= 2 * M_PI;
		vert[i][0] = (GLfloat)(sin(t) * cos(p));
		vert[i][1] = (GLfloat)(sin(t) * sin(p));
		vert[i][2] = (GLfloat)(cos(t));
	}

	glClearColor(0,0.2f,0.2f,0);

	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	glEnable(GL_LINE_SMOOTH);
	glLineWidth(1.7f);
	
	for(;;)
	{
		uiNextEvent(&ev);
		if((ev.type == ui_key_event && ev.key.scan == sc_escape) || 
			(ev.type == ui_wm_event && ev.configure.wm_event == ui_wm_close))
			break;
		switch(ev.type)
		{
			case ui_pointer_motion_event:
				if(ev.button & UI_LBUTTON_MASK)
				{
					alpha += ev.client_dx;
					beta += ev.client_dy;
				}
				break;
			case ui_key_event:
				if(ev.key.scan == sc_space)
				{
					alpha = beta = 0;
					break;
				}
				break;
			case ui_window_expose_event:
				break;
			default:
				break;
		}
		draw();
	}
	agShutdown();
	return 0;
}
